function Button(_name, _id, _type, _list){
    this.name = _name;   
    this.id = _id;
    this.type = _type;
    this.len = objButtons[this.type].len;
    this.cmd = objButtons[_type].cmd;
    
    this.widget = IR.GetPopup("buttonWidget").Clone('btn_' + _name + '_' + _id + '_' + _type);
    this.widget.GetItem("name").Text = _name; 
    this.widget.GetItem("id").Text = _id;
    this.widget.GetItem("type").Text = _type;
    
    _list.AddPopup(this.widget);    
    
    this.command = this.createCommand();

    IR.AddListener(IR.EVENT_ITEM_PRESS, this.widget.GetItem("name"), function(){
        sendFrame(this.command); 
    }, this)
}                 

//==========================================================================================

//generate commandу: cmd + user pass + data
Button.prototype.createCommand = function(){   
    var command = [];
    
    command.push(this.cmd);
            
    for (var i = 0; i < pass.length; i++){
        command.push(pass[i]);
    }
    var data = setBit(this.id, this.len);      
    for (var i = 0; i < data.length; i++){
        command.push(data[i]);
    }
    return command;
}

//==========================================================================================
//types of buttons and their commands,
//len - length of data to send
var objButtons =  [
    {cmd: 0x84,    name: "Disarm",               len: 4},
    {cmd: 0x85,    name: "Clear alarm",          len: 4},
    {cmd: 0x8A,    name: "Open door",            len: 16}  ];